use crate::log_information;
use crate::task::{exit_current_and_run_next, suspend_current_and_run_next};
use crate::timer::get_time_ms;

pub fn sys_exit(exit_state: i32) -> ! {
    log_information!("Application exited with code {}.", exit_state);
    exit_current_and_run_next();

    unreachable!()
}

pub fn sys_yield() -> usize {
    suspend_current_and_run_next();

    0
}

pub fn sys_get_time() -> usize {
    get_time_ms()
}
