use crate::config::CLOCK_FREQUENCY;
use crate::sbi::set_timer;
use riscv::register::time;

pub fn get_time() -> usize {
    time::read()
}

/// 每秒执行100次，即10ms执行一次
const TICKS_PRE_SECOND: usize = 100;

pub fn get_time_ms() -> usize {
    time::read() / CLOCK_FREQUENCY * 1000
}

pub fn set_next_trigger() {
    set_timer(get_time() + CLOCK_FREQUENCY / TICKS_PRE_SECOND);
}
