#![no_std]
#![feature(linkage)]

use crate::syscall::{sys_exit, sys_get_time, sys_write};

mod syscall;
mod utils;
#[macro_use]
pub mod console;

#[no_mangle]
#[link_section = ".text.entry"]
pub extern "C" fn _start() -> ! {
    utils::clear_bss();
    exit(main());
    panic!("Unreachable after exit main!");
}

#[no_mangle]
#[linkage = "weak"]
pub fn main() -> i32 {
    panic!("Cannot find main function!");
}

pub fn write(fd: usize, buf: &[u8]) -> isize {
    sys_write(fd, buf)
}
pub fn exit(exit_code: i32) -> isize {
    sys_exit(exit_code)
}

pub fn get_time() -> isize {
    sys_get_time()
}

pub fn sys_yield() -> isize {
    syscall::sys_yield()
}
